version: '3.9'

volumes:
  eco_col_database_db_volume:
    driver: local
  eco_col_database_manager_volume:
    driver: local

networks:
  eco_col_network:
    driver: bridge
    enable_ipv6: false
    ipam:
      driver: default
      config:
        - subnet: ${ECO_NETWORK_SUBNET}
          gateway: ${ECO_NETWORK_GATEWAY}

services:

  eco_col_api:
    profiles: [ "ecosystem_development", "ecosystem_backend" ]
    container_name: eco_col_api
    hostname: api
    build:
      context: ./
      dockerfile: scripts/d.api.Dockerfile
      target: dependencies
      args:
        USER_ID: ${USER_UID:-1000}
        GROUP_ID: ${USER_GUI:-1000}

    environment:
      PHP_IDE_CONFIG: "serverName=docker-backend-template"
      DOCKER_XDEBUG_REMOTE_HOST: "${XDEBUG_REMOTE_HOST:-host.docker.internal}"
    user:
      "${USER_UID:-1000}:${USER_GID:-1000}"
    volumes:
      - .\projects\api\project:/opt/application:rw
    expose:
      - '80'
    networks:
      eco_col_network:
        ipv4_address: ${ECO_API_IP}

  eco_col_app:
    profiles: [ "ecosystem_development", "ecosystem_frontend" ]
    container_name: eco_col_app
    hostname: app
    build:
      context: ./
      dockerfile: scripts/d.app.Dockerfile
      target: development
      args:
        USER_ID: ${USER_ID:-1000}
        GROUP_ID: ${GROUP_ID:-1000}
    environment:
      APP_URL: ${ECO_APP_URL}
    volumes:
      - .\projects\app/project:/opt/application:rw
    tty: true
    expose:
      - "5000"
    networks:
      eco_col_network:
        ipv4_address: ${ECO_APP_IP}

  eco_col_db_vm:
    profiles: [ "ecosystem_development", "ecosystem_database", "ecosystem_backend" ]
    container_name: eco_col_db_vm
    image: mongo:5.0
    environment:
      - MONGO_INITDB_ROOT_USERNAME=${ECO_DATABASE_ROOT_USER}
      - MONGO_INITDB_ROOT_PASSWORD=${ECO_DATABASE_ROOT_USER_PASSWORD}
    restart: unless-stopped
    expose:
      - "27017"
    volumes:
      - .\database\db:/data/db
      - .\database\dev.archive:/Databases/dev.archive
      - .\database\production:/Databases/production
    networks:
      eco_col_network:
        ipv4_address: ${ECO_DB_VM_IP}

  eco_col_db_management:
    profiles: [ "ecosystem_development", "ecosystem_database", "ecosystem_backend", "ecosystem_extras" ]
    container_name: eco_col_db_management
    image: mongo-express
    environment: # No custom config.js found, loading config.default.js
      - ME_CONFIG_MONGODB_SERVER=eco_col_db_vm #mongodb
      - ME_CONFIG_MONGODB_URL=mongodb://${ECO_DATABASE_ROOT_USER}:${ECO_DATABASE_ROOT_USER_PASSWORD}@eco_col_db_vm:27017/?authSource=${ECO_DATABASE_MAIN_AUTH_SOURCE}
      - ME_CONFIG_MONGODB_ADMINUSERNAME=${ECO_DATABASE_ROOT_USER}
      - ME_CONFIG_MONGODB_ADMINPASSWORD=${ECO_DATABASE_ROOT_USER_PASSWORD}
    restart: always
    expose:
      - "8081"
    depends_on:
      - eco_col_db_vm
    links:
      - eco_col_db_vm
    networks:
      eco_col_network:
        ipv4_address: ${ECO_DB_MANAGEMENT_IP}

  eco_col_mail_mailhog:
    profiles: [ "ecosystem_development", "ecosystem_backend", "ecosystem_extras" ]
    container_name: eco_col_mail_mailhog
    image: mailhog/mailhog
    environment:
      - VIRTUAL_HOST=mail.ecosystem.local
      - VIRTUAL_PORT=8025
    expose:
      - "1025"
      - "8025"
    networks:
      eco_col_network:
        ipv4_address: ${ECO_DB_MAILHOG_IP}
